import React from 'react';
import type { OverlayType } from '../types';
declare type IParams = {
    enabled?: boolean;
    onClose: () => void;
};
export declare const useKeyboardDismissable: ({ enabled, onClose }: IParams) => void;
export declare const useElementByType: (children: React.ReactNode, name: string) => undefined;
interface UseControllableStateProps<T> {
    /**
     * The value to used in controlled mode
     */
    value?: T;
    /**
     * The initial value to be used, in uncontrolled mode
     */
    defaultValue?: T | (() => T);
    /**
     * The callback fired when the value changes
     */
    onChange?: (value: T) => void;
    /**
     * The component name (for warnings)
     */
    name?: string;
}
/**
 * React hook for using controlling component state.
 * @param props
 */
export declare function useControllableState<T>(props: UseControllableStateProps<T>): [T, React.Dispatch<React.SetStateAction<T>>];
declare type IUsePopover = {
    isOpen: boolean;
    mode: OverlayType;
};
export declare const usePopover: (props: IUsePopover) => {
    triggerProps: any;
    contentProps: any;
};
declare type IOnProps = {
    on?: 'press' | 'longPress' | 'hover';
    onHoverIn?: () => void;
    onHoverOut?: () => void;
    onFocus?: () => void;
    onBlur?: () => void;
    onPress?: () => void;
    onLongPress?: () => void;
    onOpen: () => void;
    onClose: () => void;
};
export declare const useOn: (props: IOnProps) => {
    onPress: (event: unknown) => void;
    onLongPress?: undefined;
    onHoverIn?: undefined;
    onHoverOut?: undefined;
    onFocus?: undefined;
    onBlur?: undefined;
} | {
    onLongPress: (event: unknown) => void;
    onPress?: undefined;
    onHoverIn?: undefined;
    onHoverOut?: undefined;
    onFocus?: undefined;
    onBlur?: undefined;
} | {
    onHoverIn: (event: unknown) => void;
    onHoverOut: (event: unknown) => void;
    onFocus: (event: unknown) => void;
    onBlur: (event: unknown) => void;
    onPress?: undefined;
    onLongPress?: undefined;
} | {
    onPress?: undefined;
    onLongPress?: undefined;
    onHoverIn?: undefined;
    onHoverOut?: undefined;
    onFocus?: undefined;
    onBlur?: undefined;
};
export {};
